Stock events in JavaScript Stock chart control

18 Nov 201824 minutes to read

Stock Events visualizes stock events in stock chart. ‘SplineSeries’ is used to represent selected data value. You can customize the specific data value using stockEvents event.

var stockChart = new ej.charts.StockChart({
   chartArea: { border: { width: 0 } },
        primaryXAxis: { valueType: 'DateTime', majorGridLines: { color: 'transparent' }, crosshairTooltip: { enable: true } },
        primaryYAxis: {
            lineStyle: { color: 'transparent' },
            majorTickLines: { color: 'transparent' },
            crosshairTooltip: { enable: true }
        },
        series: [
            {
                dataSource: chartData, xName: 'date', yName: 'high', type: 'Spline'
            }
        ],
        stockEvents: [
            { date: new Date(2012, 3, 1), text: 'Q2', description: '2012 Quarter2 starts', type: 'Flag', background: '#6c6d6d', border: { color: '#6c6d6d' } },
            { date: new Date(2012, 3, 20), text: 'Open', description: 'Markets opened', textStyle: { color: 'white' },
              background: '#f48a21', border: { color: '#f48a21' } },
            { date: new Date(2012, 6, 1), text: 'Q3', description: '2013 Quarter3 starts', type: 'Flag',
              textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' } },
            { date: new Date(2012, 9, 1), text: 'Q4', description: '2013 Quarter4 starts', type: 'Flag',
              textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' } },
            { date: new Date(2012, 7, 30), text: 'G', description: 'Google stocks bought',
              textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' } },
            { date: new Date(2012, 10, 1), text: 'Y', description: 'Yahoo stocks sold', type: 'Square',
              textStyle: { color: 'white' }, background: '#841391', border: { color: '#841391' } },
            { date: new Date(2012, 12, 0), text: 'Y2', description: 'Year 2013', type: 'Pin', showOnSeries: false,
              textStyle: { color: 'white' }, background: '#6322e0', border: { color: '#6322e0' } },
            { date: new Date(2013, 3, 1), text: 'Q2', description: '2013 Quarter2 starts', type: 'Flag',
              textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' } },
            { date: new Date(2013, 3, 20), text: 'Q2', description: 'Surge in Stocks', type: 'ArrowUp',
              textStyle: { color: 'white' }, background: '#3ab0f9', border: { color: '#3ab0f9' } },
            { date: new Date(2013, 6, 1), text: 'Q3', description: '2013 Quarter3 starts', type: 'Flag',
              textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' } },
            { date: new Date(2013, 9, 1), text: 'Q4', description: '2013 Quarter4 starts',  type: 'Flag',
              textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' } },
            { date: new Date(2013, 12, 0), text: 'Y3', description: 'Year 2014', type: 'Pin', showOnSeries: false,
              textStyle: { color: 'white' }, background: '#6322e0', border: { color: '#6322e0' } },
            { date: new Date(2014, 3, 1), text: 'Q2', description: '2014 Quarter2 starts', type: 'ArrowDown',
              textStyle: { color: 'white' }, background: '#3ab0f9', border: { color: '#3ab0f9' } },
            { date: new Date(2014, 6, 1), text: 'Q3', description: '2014 Quarter3 starts',
              textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' } },
            { date: new Date(2014, 9, 1), text: 'Q4', description: '2014 Quarter4 starts', type: 'Flag',
              textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' } },
            { date: new Date(2014, 12, 0), text: 'Y4', description: 'Year 2015', type: 'Pin', showOnSeries: false,
              textStyle: { color: 'white' }, background: '#6322e0', border: { color: '#6322e0' } },
            { date: new Date(2014, 2, 2), text: 'End', description: 'Markets closed', type: 'ArrowDown',
              textStyle: { color: 'white' }, background: '#3ab0f9', border: { color: '#3ab0f9' } },
            { date: new Date('2015-01-07'), text: 'A', description: 'This is event description',
              textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' } },
            { date: new Date(2015, 1, 2), text: 'Q1', description: 'Add longer text',
              textStyle: { color: 'white' }, background: '#dd3c9f', border: { color: '#dd3c9f' }, type: 'Text' },
            { date: new Date(2015, 2, 12), text: 'Close', description: 'Markets closed',
              textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' } }
        ],
        seriesType : [],
        indicatorType : [],
        trendlineType: [],
        title: 'AAPL Stock Price',
        crosshair: { enable: true },
});
stockChart.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="./index.css" rel="stylesheet">
    <link href="http://cdn.syncfusion.com/ej2/material.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Stock Events for individual series

By default, stock events will be showed for all series. Now, you can set the stock events for particular series using seriesIndexes property.

var stockChart = new ej.charts.StockChart({
   chartArea: { border: { width: 0 } },
        primaryXAxis: { valueType: 'DateTime', majorGridLines: { color: 'transparent' }, crosshairTooltip: { enable: true } },
        primaryYAxis: {
            lineStyle: { color: 'transparent' },
            majorTickLines: { color: 'transparent' },
            crosshairTooltip: { enable: true }
        },
        series: [
            {
                dataSource: chartData, xName: 'date', yName: 'high', type: 'Spline'
            },
            {
                dataSource: chartData, xName: 'date', yName: 'low', type: 'Spline'
            },
            {
                dataSource: chartData, xName: 'date', yName: 'open', type: 'Spline'
            }
        ],
        stockEvents: [
            { date: new Date(2012, 3, 1), text: 'Q2', description: '2012 Quarter2 starts', type: 'Flag', background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes[0] },
            { date: new Date(2012, 3, 20), text: 'Open', description: 'Markets opened', textStyle: { color: 'white' },
              background: '#f48a21', border: { color: '#f48a21' }, seriesIndexes[0] },
            { date: new Date(2012, 6, 1), text: 'Q3', description: '2013 Quarter3 starts', type: 'Flag',
              textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes[0] },
            { date: new Date(2012, 9, 1), text: 'Q4', description: '2013 Quarter4 starts', type: 'Flag',
              textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes[0] },
            { date: new Date(2012, 7, 30), text: 'G', description: 'Google stocks bought',
              textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' }, seriesIndexes[0] },
            { date: new Date(2012, 10, 1), text: 'Y', description: 'Yahoo stocks sold', type: 'Square',
              textStyle: { color: 'white' }, background: '#841391', border: { color: '#841391' }, seriesIndexes[0] },
            { date: new Date(2012, 12, 0), text: 'Y2', description: 'Year 2013', type: 'Pin', showOnSeries: false,
              textStyle: { color: 'white' }, background: '#6322e0', border: { color: '#6322e0' }, seriesIndexes[0] },
            { date: new Date(2013, 3, 1), text: 'Q2', description: '2013 Quarter2 starts', type: 'Flag',
              textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes[0] },
            { date: new Date(2013, 3, 20), text: 'Q2', description: 'Surge in Stocks', type: 'ArrowUp',
              textStyle: { color: 'white' }, background: '#3ab0f9', border: { color: '#3ab0f9' }, seriesIndexes[1] },
            { date: new Date(2013, 6, 1), text: 'Q3', description: '2013 Quarter3 starts', type: 'Flag',
              textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes[1] },
            { date: new Date(2013, 9, 1), text: 'Q4', description: '2013 Quarter4 starts',  type: 'Flag',
              textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes[1] },
            { date: new Date(2013, 12, 0), text: 'Y3', description: 'Year 2014', type: 'Pin', showOnSeries: false,
              textStyle: { color: 'white' }, background: '#6322e0', border: { color: '#6322e0' }, seriesIndexes[1] },
            { date: new Date(2014, 3, 1), text: 'Q2', description: '2014 Quarter2 starts', type: 'ArrowDown',
              textStyle: { color: 'white' }, background: '#3ab0f9', border: { color: '#3ab0f9' }, seriesIndexes[1] },
            { date: new Date(2014, 6, 1), text: 'Q3', description: '2014 Quarter3 starts',
              textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' }, seriesIndexes[2] },
            { date: new Date(2014, 9, 1), text: 'Q4', description: '2014 Quarter4 starts', type: 'Flag',
              textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes[2] },
            { date: new Date(2014, 12, 0), text: 'Y4', description: 'Year 2015', type: 'Pin', showOnSeries: false,
              textStyle: { color: 'white' }, background: '#6322e0', border: { color: '#6322e0' }, seriesIndexes[2] },
            { date: new Date(2014, 2, 2), text: 'End', description: 'Markets closed', type: 'ArrowDown',
              textStyle: { color: 'white' }, background: '#3ab0f9', border: { color: '#3ab0f9' }, seriesIndexes[2] },
            { date: new Date('2015-01-07'), text: 'A', description: 'This is event description',
              textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' }, seriesIndexes[2] },
            { date: new Date(2015, 1, 2), text: 'Q1', description: 'Add longer text',
              textStyle: { color: 'white' }, background: '#dd3c9f', border: { color: '#dd3c9f' }, type: 'Text', seriesIndexes[2] },
            { date: new Date(2015, 2, 12), text: 'Close', description: 'Markets closed',
              textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' }, seriesIndexes[2] }
        ],
        seriesType : [],
        indicatorType : [],
        trendlineType: [],
        title: 'AAPL Stock Price',
        crosshair: { enable: true },
});
stockChart.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="./index.css" rel="stylesheet">
    <link href="http://cdn.syncfusion.com/ej2/material.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

See Also

Stock events in Vue Stock chart component

18 Nov 201824 minutes to read

Stock Events visualizes stock events in stock chart. ‘SplineSeries’ is used to represent selected data value. You can customize the specific data value using stockEvents event.

<template>
  <div class="control-section">
    <div>
      <ejs-stockchart style="display:block" id="stockchartcontainer" :primaryXAxis="primaryXAxis"
        :primaryYAxis="primaryYAxis" :chartArea="chartArea" :crosshair="crosshair" :tooltip="tooltip"
        :seriesType="seriesType" :title="title" :indicatorType="indicator" :border="border">
        <e-stockchart-series-collection>
          <e-stockchart-series :dataSource="seriesData" type="Spline" xName="date" name="Apple Inc" yName="high"
            close="high"></e-stockchart-series>
        </e-stockchart-series-collection>
        <e-stockchart-stockevents>
          <e-stockchart-stockevent :date="date1" text="Q2" description="2012 Quarter2 starts"
            type="Flag"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date2" text="Open" description="Markets opened" :textStyle="textStyle"
            background="#f48a21" :border="borderCircle"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date3" text="Q3" description="2013 Quarter3 starts" type="Flag"
            :textStyle="textStyle" background="#6c6d6d" :border="borderFlag">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date4" text="Q4" description="2013 Quarter4 starts" type="Flag"
            :textStyle="textStyle" background="#6c6d6d" :border="borderFlag">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date5" text="G" description="Google stocks bought" :textStyle="textStyle"
            background="#f48a21" :border="borderCircle">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date6" text="Y" description="Yahoo stocks sold" type="Square"
            :textStyle="textStyle" background="#841391" :border="borderSquare">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date7" text="Y2" description="Year 2013" type="Pin" :showOnSeries="onAxis"
            :textStyle="textStyle" background="#6322e0" :border="borderPin"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date8" text="Q2" description="2013 Quarter2 starts" type="Flag"
            :textStyle="textStyle" background="#6c6d6d" :border="borderFlag">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date9" text="Q2" description="Surge in Stocks" type="ArrowUp"
            :textStyle="textStyle" background="#3ab0f9" :border="borderArrow"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date10" text="Q3" description="2013 Quarter3 starts" type="Flag"
            :textStyle="textStyle" background="#6c6c6d" :border="borderFlag"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date11" text="Q4" description="2013 Quarter4 starts" type="Flag"
            :textStyle="textStyle" background="#6c6c6d" :border="borderFlag"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date12" text="Y3" description="Year 2014" type="Pin" :showOnSeries="onAxis"
            :textStyle="textStyle" background="#6322e0" :border="borderPin"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date13" text="Q2" description="2014 Quarter2 starts" type="ArrowDown"
            :textStyle="textStyle" background="#3ab0f9" :border="borderArrow"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date14" text="Q3" description="2014 Quarter3 starts" :textStyle="textStyle"
            background="#f48a21" :border="borderCircle">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date15" text="Q4" description="2014 Quarter4 starts" type="Flag"
            :textStyle="textStyle" background="#6c6d6d" :border="borderFlag"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date16" text="Y4" description="Year 2015" type="Pin" :showOnSeries="onAxis"
            :textStyle="textStyle" background="#6322e0" :border="borderPin"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date17" text="End" description="Markets closed" type="ArrowDown"
            :textStyle="textStyle" background="#3ab0f9" :border="borderArrow"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date18" text="A" description="This is event description"
            :textStyle="textStyle" background="#f48a21" :border="borderCircle"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date19" text="Q1" description="Add longer text" :textStyle="textStyle"
            background="#dd3c9f" :border="borderText" type="Text"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date20" text="Close" description="Markets closed" :textStyle="textStyle"
            background="#f48a21" :border="borderCircle"></e-stockchart-stockevent>
        </e-stockchart-stockevents>
      </ejs-stockchart>
    </div>
  </div>
</template>

<script setup>
import { provide } from "vue";

import { chartData } from "./datasource.js";
import {
  StockChartComponent as EjsStockchart, StockChartSeriesCollectionDirective as EStockchartSeriesCollection, StockChartSeriesDirective as EStockchartSeries, StockEventsDirective as EStockchartStockevents, StockEventDirective as EStockchartStockevent, DateTime, SplineSeries, Crosshair, Tooltip, RangeTooltip, LineSeries,
  CandleSeries, HiloOpenCloseSeries, HiloSeries, RangeAreaSeries, Trendlines, EmaIndicator,
  RsiIndicator, BollingerBands, TmaIndicator, MomentumIndicator, SmaIndicator, AtrIndicator,
  AccumulationDistributionIndicator, MacdIndicator, StochasticIndicator, Export
} from "@syncfusion/ej2-vue-charts";


const seriesData = chartData;
const seriesType = [];
const indicator = [];
const primaryXAxis = {
  valueType: "DateTime",
  majorGridLines: { color: "transparent" },
  crosshairTooltip: { enable: true }
};
const primaryYAxis = {
  lineStyle: { color: "transparent" },
  majorTickLines: { color: "transparent" },
  crosshairTooltip: { enable: true }
};
const chartArea = {
  border: {
    width: 0
  }
};
const date1 = new Date(2012, 3, 1);
const date2 = new Date(2012, 3, 20);
const date3 = new Date(2012, 6, 1);
const date4 = new Date(2012, 9, 1);
const date5 = new Date(2012, 7, 30);
const date6 = new Date(2012, 10, 1);
const date7 = new Date(2012, 12, 0);
const date8 = new Date(2013, 3, 1);
const date9 = new Date(2013, 3, 20);
const date10 = new Date(2013, 6, 1);
const date11 = new Date(2013, 9, 1);
const date12 = new Date(2013, 12, 0);
const date13 = new Date(2014, 3, 1);
const date14 = new Date(2014, 6, 1);
const date15 = new Date(2014, 9, 1);
const date16 = new Date(2014, 12, 0);
const date17 = new Date(2014, 2, 2);
const date18 = new Date(2015, 1, 7);
const date19 = new Date(2015, 1, 2);
const date20 = new Date(2015, 2, 12);
const textStyle = { color: "white" };
const borderFlag = { color: '#6c6d6d' };
const borderSquare = { color: '#841391' };
const borderArrow = { color: '#3ab0f9' };
const borderPin = { color: '#6233e0' };
const borderText = { color: '#dd3c9f' };
const borderCircle = { color: '#f48a21' };
const title = "AAPL Stock Price";
const tooltip = { enable: true };
const crosshair = { enable: true };
const border = { width: 0 };
const onAxis = false;

provide('stockChart', [
  DateTime, SplineSeries, Crosshair, Tooltip, RangeTooltip, LineSeries,
  CandleSeries, HiloOpenCloseSeries, HiloSeries, RangeAreaSeries, Trendlines, EmaIndicator,
  RsiIndicator, BollingerBands, TmaIndicator, MomentumIndicator, SmaIndicator, AtrIndicator,
  AccumulationDistributionIndicator, MacdIndicator, StochasticIndicator, Export
]);

</script>
<style>
#container {
  height: 350px;
}
</style>
<template>
  <div class="control-section">
    <div>
      <ejs-stockchart style="display:block" id="stockchartcontainer" :primaryXAxis="primaryXAxis"
        :primaryYAxis="primaryYAxis" :chartArea="chartArea" :crosshair="crosshair" :tooltip="tooltip"
        :seriesType="seriesType" :title="title" :indicatorType="indicator" :border="border">
        <e-stockchart-series-collection>
          <e-stockchart-series :dataSource="seriesData" type="Spline" xName="date" name="Apple Inc" yName="high"
            close="high"></e-stockchart-series>
        </e-stockchart-series-collection>
        <e-stockchart-stockevents>
          <e-stockchart-stockevent :date="date1" text="Q2" description="2012 Quarter2 starts"
            type="Flag"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date2" text="Open" description="Markets opened" :textStyle="textStyle"
            background="#f48a21" :border="borderCircle"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date3" text="Q3" description="2013 Quarter3 starts" type="Flag"
            :textStyle="textStyle" background="#6c6d6d" :border="borderFlag">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date4" text="Q4" description="2013 Quarter4 starts" type="Flag"
            :textStyle="textStyle" background="#6c6d6d" :border="borderFlag">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date5" text="G" description="Google stocks bought" :textStyle="textStyle"
            background="#f48a21" :border="borderCircle">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date6" text="Y" description="Yahoo stocks sold" type="Square"
            :textStyle="textStyle" background="#841391" :border="borderSquare">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date7" text="Y2" description="Year 2013" type="Pin" :showOnSeries="onAxis"
            :textStyle="textStyle" background="#6322e0" :border="borderPin"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date8" text="Q2" description="2013 Quarter2 starts" type="Flag"
            :textStyle="textStyle" background="#6c6d6d" :border="borderFlag">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date9" text="Q2" description="Surge in Stocks" type="ArrowUp"
            :textStyle="textStyle" background="#3ab0f9" :border="borderArrow"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date10" text="Q3" description="2013 Quarter3 starts" type="Flag"
            :textStyle="textStyle" background="#6c6c6d" :border="borderFlag"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date11" text="Q4" description="2013 Quarter4 starts" type="Flag"
            :textStyle="textStyle" background="#6c6c6d" :border="borderFlag"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date12" text="Y3" description="Year 2014" type="Pin" :showOnSeries="onAxis"
            :textStyle="textStyle" background="#6322e0" :border="borderPin"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date13" text="Q2" description="2014 Quarter2 starts" type="ArrowDown"
            :textStyle="textStyle" background="#3ab0f9" :border="borderArrow"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date14" text="Q3" description="2014 Quarter3 starts" :textStyle="textStyle"
            background="#f48a21" :border="borderCircle">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date15" text="Q4" description="2014 Quarter4 starts" type="Flag"
            :textStyle="textStyle" background="#6c6d6d" :border="borderFlag"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date16" text="Y4" description="Year 2015" type="Pin" :showOnSeries="onAxis"
            :textStyle="textStyle" background="#6322e0" :border="borderPin"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date17" text="End" description="Markets closed" type="ArrowDown"
            :textStyle="textStyle" background="#3ab0f9" :border="borderArrow"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date18" text="A" description="This is event description"
            :textStyle="textStyle" background="#f48a21" :border="borderCircle"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date19" text="Q1" description="Add longer text" :textStyle="textStyle"
            background="#dd3c9f" :border="borderText" type="Text"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date20" text="Close" description="Markets closed" :textStyle="textStyle"
            background="#f48a21" :border="borderCircle"></e-stockchart-stockevent>
        </e-stockchart-stockevents>
      </ejs-stockchart>
    </div>
  </div>
</template>

<script>

import { chartData } from "./datasource.js";
import {
  StockChartComponent, StockChartSeriesCollectionDirective, StockChartSeriesDirective, StockEventsDirective, StockEventDirective, DateTime, SplineSeries, Crosshair, Tooltip, RangeTooltip, LineSeries,
  CandleSeries, HiloOpenCloseSeries, HiloSeries, RangeAreaSeries, Trendlines, EmaIndicator,
  RsiIndicator, BollingerBands, TmaIndicator, MomentumIndicator, SmaIndicator, AtrIndicator,
  AccumulationDistributionIndicator, MacdIndicator, StochasticIndicator, Export
} from "@syncfusion/ej2-vue-charts";



export default {
  name: "App",
  components: {
    'ejs-stockchart': StockChartComponent,
    'e-stockchart-series-collection': StockChartSeriesCollectionDirective,
    'e-stockchart-series': StockChartSeriesDirective,
    'e-stockchart-stockevent': StockEventDirective,
    'e-stockchart-stockevents': StockEventsDirective
  },
  data() {
    return {
      seriesData: chartData,
      seriesType: [],
      indicator: [],
      primaryXAxis: {
        valueType: "DateTime",
        majorGridLines: { color: "transparent" },
        crosshairTooltip: { enable: true }
      },
      primaryYAxis: {
        lineStyle: { color: "transparent" },
        majorTickLines: { color: "transparent" },
        crosshairTooltip: { enable: true }
      },
      chartArea: {
        border: {
          width: 0
        }
      },
      date1: new Date(2012, 3, 1),
      date2: new Date(2012, 3, 20),
      date3: new Date(2012, 6, 1),
      date4: new Date(2012, 9, 1),
      date5: new Date(2012, 7, 30),
      date6: new Date(2012, 10, 1),
      date7: new Date(2012, 12, 0),
      date8: new Date(2013, 3, 1),
      date9: new Date(2013, 3, 20),
      date10: new Date(2013, 6, 1),
      date11: new Date(2013, 9, 1),
      date12: new Date(2013, 12, 0),
      date13: new Date(2014, 3, 1),
      date14: new Date(2014, 6, 1),
      date15: new Date(2014, 9, 1),
      date16: new Date(2014, 12, 0),
      date17: new Date(2014, 2, 2),
      date18: new Date(2015, 1, 7),
      date19: new Date(2015, 1, 2),
      date20: new Date(2015, 2, 12),
      textStyle: { color: "white" },
      borderFlag: { color: '#6c6d6d' },
      borderSquare: { color: '#841391' },
      borderArrow: { color: '#3ab0f9' },
      borderPin: { color: '#6233e0' },
      borderText: { color: '#dd3c9f' },
      borderCircle: { color: '#f48a21' },
      title: "AAPL Stock Price",
      tooltip: { enable: true },
      crosshair: { enable: true },
      border: { width: 0 },
      onAxis: false
    };
  },
  provide: {
    stockChart: [
      DateTime, SplineSeries, Crosshair, Tooltip, RangeTooltip, LineSeries,
      CandleSeries, HiloOpenCloseSeries, HiloSeries, RangeAreaSeries, Trendlines, EmaIndicator,
      RsiIndicator, BollingerBands, TmaIndicator, MomentumIndicator, SmaIndicator, AtrIndicator,
      AccumulationDistributionIndicator, MacdIndicator, StochasticIndicator, Export
    ]
  }
};
</script>
<style>
#container {
  height: 350px;
}
</style>

Stock Events for individual series

By default, stock events will be showed for all series. Now, you can set the stock events for particular series using seriesIndexes property.

<template>
  <div class="control-section">
    <div>
      <ejs-stockchart style="display:block" id="stockchartcontainer" :primaryXAxis="primaryXAxis"
        :primaryYAxis="primaryYAxis" :chartArea="chartArea" :crosshair="crosshair" :tooltip="tooltip"
        :seriesType="seriesType" :title="title" :indicatorType="indicator" :border="border">
        <e-stockchart-series-collection>
          <e-stockchart-series :dataSource="seriesData" type="Spline" xName="date" yName="high"></e-stockchart-series>
          <e-stockchart-series :dataSource="seriesData" type="Spline" xName="date" yName="low"></e-stockchart-series>
          <e-stockchart-series :dataSource="seriesData" type="Spline" xName="date" yName="open"></e-stockchart-series>
        </e-stockchart-series-collection>
        <e-stockchart-stockevents>
          <e-stockchart-stockevent :date="date1" text="Q2" description="2012 Quarter2 starts" type="Flag"
            :seriesIndexes="index1"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date2" text="Open" description="Markets opened" :textStyle="textStyle"
            background="#f48a21" :border="borderCircle"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date3" text="Q3" description="2013 Quarter3 starts" type="Flag"
            :textStyle="textStyle" background="#6c6d6d" :border="borderFlag" :seriesIndexes="index2">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date4" text="Q4" description="2013 Quarter4 starts" type="Flag"
            :textStyle="textStyle" background="#6c6d6d" :border="borderFlag" :seriesIndexes="index3">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date5" text="G" description="Google stocks bought" :textStyle="textStyle"
            background="#f48a21" :border="borderCircle">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date6" text="Y" description="Yahoo stocks sold" type="Square"
            :textStyle="textStyle" background="#841391" :border="borderSquare" :seriesIndexes="index4">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date7" text="Y2" description="Year 2013" type="Pin" :showOnSeries="onAxis"
            :textStyle="textStyle" background="#6322e0" :border="borderPin"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date8" text="Q2" description="2013 Quarter2 starts" type="Flag"
            :textStyle="textStyle" background="#6c6d6d" :border="borderFlag" :seriesIndexes="index5">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date9" text="Q2" description="Surge in Stocks" type="ArrowUp"
            :textStyle="textStyle" background="#3ab0f9" :border="borderArrow"
            :seriesIndexes="index6"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date10" text="Q3" description="2013 Quarter3 starts" type="Flag"
            :textStyle="textStyle" background="#6c6c6d" :border="borderFlag"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date11" text="Q4" description="2013 Quarter4 starts" type="Flag"
            :textStyle="textStyle" background="#6c6c6d" :border="borderFlag"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date12" text="Y3" description="Year 2014" type="Pin" :showOnSeries="onAxis"
            :textStyle="textStyle" background="#6322e0" :border="borderPin"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date13" text="Q2" description="2014 Quarter2 starts" type="ArrowDown"
            :textStyle="textStyle" background="#3ab0f9" :border="borderArrow"
            :seriesIndexes="index7"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date14" text="Q3" description="2014 Quarter3 starts" :textStyle="textStyle"
            background="#f48a21" :border="borderCircle">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date15" text="Q4" description="2014 Quarter4 starts" type="Flag"
            :textStyle="textStyle" background="#6c6d6d" :border="borderFlag"
            :seriesIndexes="index8"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date16" text="Y4" description="Year 2015" type="Pin" :showOnSeries="onAxis"
            :textStyle="textStyle" background="#6322e0" :border="borderPin"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date17" text="End" description="Markets closed" type="ArrowDown"
            :textStyle="textStyle" background="#3ab0f9" :border="borderArrow"
            :seriesIndexes="index9"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date18" text="A" description="This is event description"
            :textStyle="textStyle" background="#f48a21" :border="borderCircle"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date19" text="Q1" description="Add longer text" :textStyle="textStyle"
            background="#dd3c9f" :border="borderText" type="Text" :seriesIndexes="index1"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date20" text="Close" description="Markets closed" :textStyle="textStyle"
            background="#f48a21" :border="borderCircle" :seriesIndexes="index2"></e-stockchart-stockevent>
        </e-stockchart-stockevents>
      </ejs-stockchart>
    </div>
  </div>
</template>

<script setup>
import { provide } from "vue";

import { chartData } from "./datasource.js";
import {
  StockChartComponent as EjsStockchart, StockChartSeriesCollectionDirective as EStockchartSeriesCollection, StockChartSeriesDirective as EStockchartSeries, StockEventsDirective as EStockchartStockevents, StockEventDirective as EStockchartStockevent, DateTime, SplineSeries, Crosshair, Tooltip, RangeTooltip, LineSeries,
  CandleSeries, HiloOpenCloseSeries, HiloSeries, RangeAreaSeries, Trendlines, EmaIndicator,
  RsiIndicator, BollingerBands, TmaIndicator, MomentumIndicator, SmaIndicator, AtrIndicator,
  AccumulationDistributionIndicator, MacdIndicator, StochasticIndicator, Export
} from "@syncfusion/ej2-vue-charts";


const seriesData = chartData;
const seriesType = [];
const indicator = [];
const primaryXAxis = {
  valueType: "DateTime",
  majorGridLines: { color: "transparent" },
  crosshairTooltip: { enable: true }
};
const primaryYAxis = {
  lineStyle: { color: "transparent" },
  majorTickLines: { color: "transparent" },
  crosshairTooltip: { enable: true }
};
const chartArea = {
  border: {
    width: 0
  }
};
const date1 = new Date(2012, 3, 1);
const date2 = new Date(2012, 3, 20);
const date3 = new Date(2012, 6, 1);
const date4 = new Date(2012, 9, 1);
const date5 = new Date(2012, 7, 30);
const date6 = new Date(2012, 10, 1);
const date7 = new Date(2012, 12, 0);
const date8 = new Date(2013, 3, 1);
const date9 = new Date(2013, 3, 20);
const date10 = new Date(2013, 6, 1);
const date11 = new Date(2013, 9, 1);
const date12 = new Date(2013, 12, 0);
const date13 = new Date(2014, 3, 1);
const date14 = new Date(2014, 6, 1);
const date15 = new Date(2014, 9, 1);
const date16 = new Date(2014, 12, 0);
const date17 = new Date(2014, 2, 2);
const date18 = new Date(2015, 1, 7);
const date19 = new Date(2015, 1, 2);
const date20 = new Date(2015, 2, 12);
const textStyle = { color: "white" };
const borderFlag = { color: '#6c6d6d' };
const borderSquare = { color: '#841391' };
const borderArrow = { color: '#3ab0f9' };
const borderPin = { color: '#6233e0' };
const borderText = { color: '#dd3c9f' };
const borderCircle = { color: '#f48a21' };
const title = "AAPL Stock Price";
const tooltip = { enable: true };
const crosshair = { enable: true };
const border = { width: 0 };
const onAxis = false;
const index1 = [0];
const index2 = [1];
const index3 = [2];
const index4 = [0];
const index5 = [1];
const index6 = [2];
const index7 = [0];
const index8 = [1];
const index9 = [2];

provide('stockChart', [
  DateTime, SplineSeries, Crosshair, Tooltip, RangeTooltip, LineSeries,
  CandleSeries, HiloOpenCloseSeries, HiloSeries, RangeAreaSeries, Trendlines, EmaIndicator,
  RsiIndicator, BollingerBands, TmaIndicator, MomentumIndicator, SmaIndicator, AtrIndicator,
  AccumulationDistributionIndicator, MacdIndicator, StochasticIndicator, Export
]);

</script>
<style>
#container {
  height: 350px;
}
</style>
<template>
  <div class="control-section">
    <div>
      <ejs-stockchart style="display:block" id="stockchartcontainer" :primaryXAxis="primaryXAxis"
        :primaryYAxis="primaryYAxis" :chartArea="chartArea" :crosshair="crosshair" :tooltip="tooltip"
        :seriesType="seriesType" :title="title" :indicatorType="indicator" :border="border">
        <e-stockchart-series-collection>
          <e-stockchart-series :dataSource="seriesData" type="Spline" xName="date" yName="high"></e-stockchart-series>
          <e-stockchart-series :dataSource="seriesData" type="Spline" xName="date" yName="low"></e-stockchart-series>
          <e-stockchart-series :dataSource="seriesData" type="Spline" xName="date" yName="open"></e-stockchart-series>
        </e-stockchart-series-collection>
        <e-stockchart-stockevents>
          <e-stockchart-stockevent :date="date1" text="Q2" description="2012 Quarter2 starts" type="Flag"
            :seriesIndexes="index1"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date2" text="Open" description="Markets opened" :textStyle="textStyle"
            background="#f48a21" :border="borderCircle"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date3" text="Q3" description="2013 Quarter3 starts" type="Flag"
            :textStyle="textStyle" background="#6c6d6d" :border="borderFlag" :seriesIndexes="index2">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date4" text="Q4" description="2013 Quarter4 starts" type="Flag"
            :textStyle="textStyle" background="#6c6d6d" :border="borderFlag" :seriesIndexes="index3">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date5" text="G" description="Google stocks bought" :textStyle="textStyle"
            background="#f48a21" :border="borderCircle">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date6" text="Y" description="Yahoo stocks sold" type="Square"
            :textStyle="textStyle" background="#841391" :border="borderSquare" :seriesIndexes="index4">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date7" text="Y2" description="Year 2013" type="Pin" :showOnSeries="onAxis"
            :textStyle="textStyle" background="#6322e0" :border="borderPin"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date8" text="Q2" description="2013 Quarter2 starts" type="Flag"
            :textStyle="textStyle" background="#6c6d6d" :border="borderFlag" :seriesIndexes="index5">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date9" text="Q2" description="Surge in Stocks" type="ArrowUp"
            :textStyle="textStyle" background="#3ab0f9" :border="borderArrow"
            :seriesIndexes="index6"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date10" text="Q3" description="2013 Quarter3 starts" type="Flag"
            :textStyle="textStyle" background="#6c6c6d" :border="borderFlag"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date11" text="Q4" description="2013 Quarter4 starts" type="Flag"
            :textStyle="textStyle" background="#6c6c6d" :border="borderFlag"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date12" text="Y3" description="Year 2014" type="Pin" :showOnSeries="onAxis"
            :textStyle="textStyle" background="#6322e0" :border="borderPin"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date13" text="Q2" description="2014 Quarter2 starts" type="ArrowDown"
            :textStyle="textStyle" background="#3ab0f9" :border="borderArrow"
            :seriesIndexes="index7"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date14" text="Q3" description="2014 Quarter3 starts" :textStyle="textStyle"
            background="#f48a21" :border="borderCircle">
          </e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date15" text="Q4" description="2014 Quarter4 starts" type="Flag"
            :textStyle="textStyle" background="#6c6d6d" :border="borderFlag"
            :seriesIndexes="index8"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date16" text="Y4" description="Year 2015" type="Pin" :showOnSeries="onAxis"
            :textStyle="textStyle" background="#6322e0" :border="borderPin"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date17" text="End" description="Markets closed" type="ArrowDown"
            :textStyle="textStyle" background="#3ab0f9" :border="borderArrow"
            :seriesIndexes="index9"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date18" text="A" description="This is event description"
            :textStyle="textStyle" background="#f48a21" :border="borderCircle"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date19" text="Q1" description="Add longer text" :textStyle="textStyle"
            background="#dd3c9f" :border="borderText" type="Text" :seriesIndexes="index1"></e-stockchart-stockevent>
          <e-stockchart-stockevent :date="date20" text="Close" description="Markets closed" :textStyle="textStyle"
            background="#f48a21" :border="borderCircle" :seriesIndexes="index2"></e-stockchart-stockevent>
        </e-stockchart-stockevents>
      </ejs-stockchart>
    </div>
  </div>
</template>

<script>

import { chartData } from "./datasource.js";
import {
  StockChartComponent, StockChartSeriesCollectionDirective, StockChartSeriesDirective, StockEventsDirective, StockEventDirective, DateTime, SplineSeries, Crosshair, Tooltip, RangeTooltip, LineSeries,
  CandleSeries, HiloOpenCloseSeries, HiloSeries, RangeAreaSeries, Trendlines, EmaIndicator,
  RsiIndicator, BollingerBands, TmaIndicator, MomentumIndicator, SmaIndicator, AtrIndicator,
  AccumulationDistributionIndicator, MacdIndicator, StochasticIndicator, Export
} from "@syncfusion/ej2-vue-charts";



export default {
  name: "App",
  components: {
    'ejs-stockchart': StockChartComponent,
    'e-stockchart-series-collection': StockChartSeriesCollectionDirective,
    'e-stockchart-series': StockChartSeriesDirective,
    'e-stockchart-stockevent': StockEventDirective,
    'e-stockchart-stockevents': StockEventsDirective
  },
  data() {
    return {
      seriesData: chartData,
      seriesType: [],
      indicator: [],
      primaryXAxis: {
        valueType: "DateTime",
        majorGridLines: { color: "transparent" },
        crosshairTooltip: { enable: true }
      },
      primaryYAxis: {
        lineStyle: { color: "transparent" },
        majorTickLines: { color: "transparent" },
        crosshairTooltip: { enable: true }
      },
      chartArea: {
        border: {
          width: 0
        }
      },
      date1: new Date(2012, 3, 1),
      date2: new Date(2012, 3, 20),
      date3: new Date(2012, 6, 1),
      date4: new Date(2012, 9, 1),
      date5: new Date(2012, 7, 30),
      date6: new Date(2012, 10, 1),
      date7: new Date(2012, 12, 0),
      date8: new Date(2013, 3, 1),
      date9: new Date(2013, 3, 20),
      date10: new Date(2013, 6, 1),
      date11: new Date(2013, 9, 1),
      date12: new Date(2013, 12, 0),
      date13: new Date(2014, 3, 1),
      date14: new Date(2014, 6, 1),
      date15: new Date(2014, 9, 1),
      date16: new Date(2014, 12, 0),
      date17: new Date(2014, 2, 2),
      date18: new Date(2015, 1, 7),
      date19: new Date(2015, 1, 2),
      date20: new Date(2015, 2, 12),
      textStyle: { color: "white" },
      borderFlag: { color: '#6c6d6d' },
      borderSquare: { color: '#841391' },
      borderArrow: { color: '#3ab0f9' },
      borderPin: { color: '#6233e0' },
      borderText: { color: '#dd3c9f' },
      borderCircle: { color: '#f48a21' },
      title: "AAPL Stock Price",
      tooltip: { enable: true },
      crosshair: { enable: true },
      border: { width: 0 },
      onAxis: false,
      index1: [0],
      index2: [1],
      index3: [2],
      index4: [0],
      index5: [1],
      index6: [2],
      index7: [0],
      index8: [1],
      index9: [2]
    };
  },
  provide: {
    stockChart: [
      DateTime, SplineSeries, Crosshair, Tooltip, RangeTooltip, LineSeries,
      CandleSeries, HiloOpenCloseSeries, HiloSeries, RangeAreaSeries, Trendlines, EmaIndicator,
      RsiIndicator, BollingerBands, TmaIndicator, MomentumIndicator, SmaIndicator, AtrIndicator,
      AccumulationDistributionIndicator, MacdIndicator, StochasticIndicator, Export
    ]
  }
};
</script>
<style>
#container {
  height: 350px;
}
</style>

Stock events in Angular Stock chart component

18 Nov 201824 minutes to read

Stock Events visualizes stock events in stock chart. ‘SplineSeries’ is used to represent selected data value. You can customize the specific data value using stockEvents event.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ChartModule, StockChartAllModule, ChartAllModule, RangeNavigatorModule } from '@syncfusion/ej2-angular-charts'
import { LineSeriesService, SplineSeriesService, RangeTooltipService, StepLineSeriesService, CategoryService, ParetoSeriesService, ColumnSeriesService,
       SplineAreaSeriesService, MultiColoredLineSeriesService, TooltipService} from '@syncfusion/ej2-angular-charts'



import { Component, OnInit } from '@angular/core';
import { chartData } from './datasource';
import { IStockChartEventArgs, ChartTheme, ITooltipRenderEventArgs } from '@syncfusion/ej2-angular-charts';
@Component({
imports: [
         ChartModule, StockChartAllModule, ChartAllModule, RangeNavigatorModule
    ],

providers: [ LineSeriesService, SplineSeriesService, RangeTooltipService, StepLineSeriesService, CategoryService, SplineAreaSeriesService, ParetoSeriesService, ColumnSeriesService,
               MultiColoredLineSeriesService, TooltipService ],
standalone: true,
    selector: 'app-container',
    template: `<ejs-stockchart id='stockChartEvents' [enablePeriodSelector]='enable' [title]='title' [titleStyle]='titleStyle'
            [chartArea]='chartArea' [primaryXAxis]='primaryXAxis' style="display:block;" [tooltip]='tooltip'
            [crosshair]='crosshair' [primaryYAxis]='primaryYAxis' (tooltipRender)='tooltipRender($event)' [seriesType]='seriesType'
            [indicatorType]='indicatorType'>
            <e-stockchart-series-collection>
                <e-stockchart-series [dataSource]='data1' type='Spline' xName='date' yName='high' close='close'>
                </e-stockchart-series>
            </e-stockchart-series-collection>
            <e-stockchart-stockevents>
                <e-stockchart-stockevent [date]="date1" text="Q2" description="2012 Quarter2"
                    type="Flag"  background='#6c6d6d' [border]="border1"></e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date2" text="Open" description="Markets opened"
                    [textStyle]="textStyle" background="#f48a21" [border]="border2"></e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date3" text="Q3" description="2013 Quarter3"
                    type="Flag" [textStyle]="textStyle" background="#6c6d6d" [border]="border3">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date4" text="Q4" description="2013 Quarter4"
                    type="Flag" [textStyle]="textStyle" background="#6c6d6d" [border]="border3">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date5" text="G" description="Google Stock"
                    [textStyle]="textStyle" background="#f48a21" [border]="border2"></e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date6" text="Y" description="Yahoo Stock"
                    type="Square" [textStyle]="textStyle" background="#841391" [border]="border5">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date7" text="Y2" description="Year 2013" type="Pin"
                    [showOnSeries]="onSeries" [textStyle]="textStyle" background="#6322e0" [border]="border6">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date8" text="Q2" description="2013 Quarter2"
                    type="Flag" [textStyle]="textStyle" background="#6c6d6d" [border]="border3">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date9" text="Q2" description="Surge in Stocks"
                    type="ArrowUp" [textStyle]="textStyle" background="#3ab0f9" [border]="border4">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date10" text="Q3" description="2013 Quarter3"
                    type="Flag" [textStyle]="textStyle" background="#f48a21" [border]="border2">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date11" text="Q4" description="2013 Quarter4"
                    type="Flag" [textStyle]="textStyle" background="#6c6d6d" [border]="border3">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date12" text="Y3" description="Year 2014" type="Pin"
                    [showOnSeries]="onSeries" [textStyle]="textStyle" background="#6322e0" [border]="border6">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date13" text="Q2" description="2014 Quarter2"
                    type="Flag" [textStyle]="textStyle" background="#6c6d6d" [border]="border3">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date14" text="Q3" description="2014 Quarter3"
                    [textStyle]="textStyle" background="#f48a21" [border]="border2"></e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date15" text="Q4" description="2014 Quarter4"
                    type="Flag" [textStyle]="textStyle" background="#6c6d6d" [border]="border3">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date16" text="Y4" description="Year 2015" type="Pin"
                    [showOnSeries]="onSeries" [textStyle]="textStyle" background="#6322e0" [border]="border6">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date17" text="End" description="Markets closed"
                    type="ArrowDown" [textStyle]="textStyle" background="#3ab0f9" [border]="border4">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date18" text="A" description="Amazon Stock"
                    [textStyle]="textStyle" background="#f48a21" [border]="border2"></e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date19" text="Q1" description="AAPL Stock"
                    [textStyle]="textStyle" background="#dd3c9f" [border]="border7" type="Text">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date20" text="Close" description="Markets closed"
                    [textStyle]="textStyle" background="#f48a21" [border]="border2"></e-stockchart-stockevent>
            </e-stockchart-stockevents>
        </ejs-stockchart>`
})
export class AppComponent implements OnInit {
    tooltipRender($event: any) {
        throw new Error('Method not implemented.');
    }
    public primaryXAxis?: Object;
    public data1?: Object[];
    public title?: string;
    public primaryYAxis?: Object;
    public marker?: Object;
    public tooltip?: Object;
    public date1:  Date = new Date(2012, 3, 1);
    public date2:  Date = new Date(2012, 3, 20);
    public date3:  Date = new Date(2012, 6, 1);
    public date4:  Date = new Date(2012, 9, 1);
    public date5:  Date = new Date(2012, 7, 30);
    public date6:  Date = new Date(2012, 10, 1);
    public date7:  Date = new Date(2012, 12, 0);
    public date8:  Date = new Date(2013, 3, 1);
    public date9:  Date = new Date(2013, 3, 20);
    public date10: Date =  new Date(2013, 6, 1);
    public date11: Date =  new Date(2013, 9, 1);
    public date12: Date =  new Date(2013, 12, 0);
    public date13: Date =  new Date(2014, 3, 1);
    public date14: Date =  new Date(2014, 6, 1);
    public date15: Date =  new Date(2014, 9, 1);
    public date16: Date =  new Date(2014, 12, 0);
    public date17: Date =  new Date(2014, 2, 2);
    public date18: Date =  new Date(2015, 1, 7);
    public date19: Date =  new Date(2015, 1, 2);
    public date20: Date =  new Date(2015, 2, 12);
    public border1: object = { color: '#6c6d6d' };
    public textStyle: object = { color: 'white' };
    public border2: object = { color: '#f48a21' };
    public border3: object = { color: '#6c6d6d' };
    public border4: object = { color: '#3ab0f9' };
    public border5: object = { color: '#841391' };
    public border6: object = { color: '#6322e0' };
    public border7: object = { color: '#dd3c9f' };
    enable: any;
    titleStyle: any;
    chartArea: any;
    crosshair: any;
    seriesType: any;
    indicatorType: any;
    onSeries: any;
    ngOnInit(): void {
        this.data1 = chartData;
        this.primaryXAxis = {
            valueType: 'DateTime',
        };
        this.tooltip = { enable: true };
        this.marker = { visible: true, width: 10, height: 10 };
        this.title = 'Unemployment Rates 1975-2010';
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Stock Events for individual series

By default, stock events will be showed for all series. Now, you can set the stock events for particular series using seriesIndexes property.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ChartModule, StockChartAllModule, ChartAllModule, RangeNavigatorModule } from '@syncfusion/ej2-angular-charts'
import { LineSeriesService, SplineSeriesService, RangeTooltipService, StepLineSeriesService, CategoryService, ParetoSeriesService, ColumnSeriesService,
       SplineAreaSeriesService, MultiColoredLineSeriesService, TooltipService} from '@syncfusion/ej2-angular-charts'



import { Component, OnInit } from '@angular/core';
import { chartData } from './datasource';
import { IStockChartEventArgs, ChartTheme, ITooltipRenderEventArgs } from '@syncfusion/ej2-angular-charts';
@Component({
imports: [
         ChartModule, StockChartAllModule, ChartAllModule, RangeNavigatorModule
    ],

providers: [ LineSeriesService, SplineSeriesService, RangeTooltipService, StepLineSeriesService, CategoryService, SplineAreaSeriesService, ParetoSeriesService, ColumnSeriesService,
               MultiColoredLineSeriesService, TooltipService ],
standalone: true,
    selector: 'app-container',
    template: `<ejs-stockchart id='stockChartEvents' [enablePeriodSelector]='enable' [title]='title' [titleStyle]='titleStyle'
            [chartArea]='chartArea' [primaryXAxis]='primaryXAxis' style="display:block;" [tooltip]='tooltip'
            [crosshair]='crosshair' [primaryYAxis]='primaryYAxis' (tooltipRender)='tooltipRender($event)' [seriesType]='seriesType'
            [indicatorType]='indicatorType'>
            <e-stockchart-series-collection>
                <e-stockchart-series [dataSource]='data1' type='Spline' xName='date' yName='high'>
                </e-stockchart-series>
                <e-stockchart-series [dataSource]='data1' type='Spline' xName='date' yName='low'>
                </e-stockchart-series>
            </e-stockchart-series-collection>
            <e-stockchart-stockevents>
                <e-stockchart-stockevent [date]="date1" text="Q2" description="2012 Quarter2"
                    type="Flag"  background='#6c6d6d' [border]="border1" [seriesIndexes]="seriesIndex1"></e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date2" text="Open" description="Markets opened"
                    [textStyle]="textStyle" background="#f48a21" [border]="border2"></e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date3" text="Q3" description="2013 Quarter3"
                    type="Flag" [textStyle]="textStyle" background="#6c6d6d" [border]="border3">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date4" text="Q4" description="2013 Quarter4"
                    type="Flag" [textStyle]="textStyle" background="#6c6d6d" [border]="border3" [seriesIndexes]="seriesIndex2">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date5" text="G" description="Google Stock"
                    [textStyle]="textStyle" background="#f48a21" [border]="border2"></e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date6" text="Y" description="Yahoo Stock"
                    type="Square" [textStyle]="textStyle" background="#841391" [border]="border5" [seriesIndexes]="seriesIndex3">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date7" text="Y2" description="Year 2013" type="Pin"
                    [showOnSeries]="onSeries" [textStyle]="textStyle" background="#6322e0" [border]="border6">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date8" text="Q2" description="2013 Quarter2"
                    type="Flag" [textStyle]="textStyle" background="#6c6d6d" [border]="border3">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date9" text="Q2" description="Surge in Stocks"
                    type="ArrowUp" [textStyle]="textStyle" background="#3ab0f9" [border]="border4" [seriesIndexes]="seriesIndex4">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date10" text="Q3" description="2013 Quarter3"
                    type="Flag" [textStyle]="textStyle" background="#f48a21" [border]="border2">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date11" text="Q4" description="2013 Quarter4"
                    type="Flag" [textStyle]="textStyle" background="#6c6d6d" [border]="border3">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date12" text="Y3" description="Year 2014" type="Pin"
                    [showOnSeries]="onSeries" [textStyle]="textStyle" background="#6322e0" [border]="border6" [seriesIndexes]="seriesIndex5">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date13" text="Q2" description="2014 Quarter2"
                    type="Flag" [textStyle]="textStyle" background="#6c6d6d" [border]="border3" [seriesIndexes]="seriesIndex6">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date14" text="Q3" description="2014 Quarter3"
                    [textStyle]="textStyle" background="#f48a21" [border]="border2"></e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date15" text="Q4" description="2014 Quarter4"
                    type="Flag" [textStyle]="textStyle" background="#6c6d6d" [border]="border3">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date16" text="Y4" description="Year 2015" type="Pin"
                    [showOnSeries]="onSeries" [textStyle]="textStyle" background="#6322e0" [border]="border6" [seriesIndexes]="seriesIndex7">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date17" text="End" description="Markets closed"
                    type="ArrowDown" [textStyle]="textStyle" background="#3ab0f9" [border]="border4">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date18" text="A" description="Amazon Stock"
                    [textStyle]="textStyle" background="#f48a21" [border]="border2"></e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date19" text="Q1" description="AAPL Stock"
                    [textStyle]="textStyle" background="#dd3c9f" [border]="border7" type="Text" [seriesIndexes]="seriesIndex8">
                </e-stockchart-stockevent>
                <e-stockchart-stockevent [date]="date20" text="Close" description="Markets closed"
                    [textStyle]="textStyle" background="#f48a21" [border]="border2"></e-stockchart-stockevent>
            </e-stockchart-stockevents>
        </ejs-stockchart>`
})
export class AppComponent implements OnInit {
    indicatorType: any;
    crosshair: any;
    chartArea: any;
    onSeries: any;
    titleStyle: any;
    seriesType: any;
    tooltipRender($event: any) {
        throw new Error('Method not implemented.');
    }
    public primaryXAxis?: Object;
    public data1?: Object[];
    public title?: string;
    public primaryYAxis?: Object;
    public marker?: Object;
    public tooltip?: Object;
    public date1:  Date = new Date(2012, 3, 1);
    public date2:  Date = new Date(2012, 3, 20);
    public date3:  Date = new Date(2012, 6, 1);
    public date4:  Date = new Date(2012, 9, 1);
    public date5:  Date = new Date(2012, 7, 30);
    public date6:  Date = new Date(2012, 10, 1);
    public date7:  Date = new Date(2012, 12, 0);
    public date8:  Date = new Date(2013, 3, 1);
    public date9:  Date = new Date(2013, 3, 20);
    public date10: Date =  new Date(2013, 6, 1);
    public date11: Date =  new Date(2013, 9, 1);
    public date12: Date =  new Date(2013, 12, 0);
    public date13: Date =  new Date(2014, 3, 1);
    public date14: Date =  new Date(2014, 6, 1);
    public date15: Date =  new Date(2014, 9, 1);
    public date16: Date =  new Date(2014, 12, 0);
    public date17: Date =  new Date(2014, 2, 2);
    public date18: Date =  new Date(2015, 1, 7);
    public date19: Date =  new Date(2015, 1, 2);
    public date20: Date =  new Date(2015, 2, 12);
    public border1: object = { color: '#6c6d6d' };
    public textStyle: object = { color: 'white' };
    public border2: object = { color: '#f48a21' };
    public border3: object = { color: '#6c6d6d' };
    public border4: object = { color: '#3ab0f9' };
    public border5: object = { color: '#841391' };
    public border6: object = { color: '#6322e0' };
    public border7: object = { color: '#dd3c9f' };
    public seriesIndex1: number[] = [0];
    public seriesIndex2: number[] = [1];
    public seriesIndex3: number[] = [0];
    public seriesIndex4: number[] = [1];
    public seriesIndex5: number[] = [0];
    public seriesIndex6: number[] = [1];
    public seriesIndex7: number[] = [0];
    public seriesIndex8: number[] = [1];
enable: any;
    ngOnInit(): void {
        this.data1 = chartData;
        this.primaryXAxis = {
            valueType: 'DateTime',
        };
        this.tooltip = { enable: true };
        this.marker = { visible: true, width: 10, height: 10 };
        this.title = 'Unemployment Rates 1975-2010';
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Stock events in React Stock chart component

18 Nov 201824 minutes to read

Stock Events visualizes stock events in stock chart. ‘SplineSeries’ is used to represent selected data value. You can customize the specific data value using stockEvents event.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { StockChartComponent, StockChartSeriesCollectionDirective, StockChartSeriesDirective, Inject, DateTime, StripLine, LineSeries, SplineSeries, CandleSeries, HiloOpenCloseSeries, HiloSeries, RangeAreaSeries, Trendlines, Crosshair } from '@syncfusion/ej2-react-charts';
import { EmaIndicator, RsiIndicator, BollingerBands, TmaIndicator, MomentumIndicator, SmaIndicator, AtrIndicator, AccumulationDistributionIndicator, MacdIndicator, StochasticIndicator, Export } from '@syncfusion/ej2-react-charts';
import { aapl } from '../datasource';
function App() {
    const primaryxAxis = {
        valueType: 'DateTime', majorGridLines: { color: 'transparent' },
        crosshairTooltip: { enable: true }
    };
    const primaryyAxis = {
        lineStyle: { color: 'transparent' },
        majorTickLines: { color: 'transparent' },
        crosshairTooltip: { enable: true }
    };
    return <StockChartComponent id='stockcharts' primaryXAxis={primaryxAxis} primaryYAxis={primaryyAxis} indicatorType={[]} seriesType={[]} trendlineType={[]} title='AAPL Stock Price' height='350' stockEvents={[
            { date: new Date(2012, 3, 1), text: 'Q2', description: '2012 Quarter2 starts', type: 'Flag' },
            {
                date: new Date(2012, 3, 20), text: 'Open', description: 'Markets opened', textStyle: { color: 'white' },
                background: '#f48a21', border: { color: '#f48a21' }
            },
            {
                date: new Date(2012, 6, 1), text: 'Q3', description: '2013 Quarter3 starts', type: 'Flag',
                textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }
            },
            {
                date: new Date(2012, 9, 1), text: 'Q4', description: '2013 Quarter4 starts', type: 'Flag',
                textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }
            },
            {
                date: new Date(2012, 7, 30), text: 'G', description: 'Google stocks bought',
                textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' }
            },
            {
                date: new Date(2012, 10, 1), text: 'Y', description: 'Yahoo stocks sold', type: 'Square',
                textStyle: { color: 'white' }, background: '#841391', border: { color: '#841391' }
            },
            {
                date: new Date(2012, 12, 0), text: 'Y2', description: 'Year 2013', type: 'Pin', showOnSeries: false,
                textStyle: { color: 'white' }, background: '#6322e0', border: { color: '#6322e0' }
            },
            {
                date: new Date(2013, 3, 1), text: 'Q2', description: '2013 Quarter2 starts', type: 'Flag',
                textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }
            },
            {
                date: new Date(2013, 3, 20), text: 'Q2', description: 'Surge in Stocks', type: 'ArrowUp',
                textStyle: { color: 'white' }, background: '#3ab0f9', border: { color: '#3ab0f9' }
            },
            {
                date: new Date(2013, 6, 1), text: 'Q3', description: '2013 Quarter3 starts', type: 'Flag',
                textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }
            },
            {
                date: new Date(2013, 9, 1), text: 'Q4', description: '2013 Quarter4 starts', type: 'Flag',
                textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }
            },
            {
                date: new Date(2013, 12, 0), text: 'Y3', description: 'Year 2014', type: 'Pin', showOnSeries: false,
                textStyle: { color: 'white' }, background: '#6322e0', border: { color: '#6322e0' }
            },
            {
                date: new Date(2014, 3, 1), text: 'Q2', description: '2014 Quarter2 starts', type: 'ArrowDown',
                textStyle: { color: 'white' }, background: '#3ab0f9', border: { color: '#3ab0f9' }
            },
            {
                date: new Date(2014, 6, 1), text: 'Q3', description: '2014 Quarter3 starts',
                textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' }
            },
            {
                date: new Date(2014, 9, 1), text: 'Q4', description: '2014 Quarter4 starts', type: 'Flag',
                textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }
            },
            {
                date: new Date(2014, 12, 0), text: 'Y4', description: 'Year 2015', type: 'Pin', showOnSeries: false,
                textStyle: { color: 'white' }, background: '#6322e0', border: { color: '#6322e0' }
            },
            {
                date: new Date(2014, 2, 2), text: 'End', description: 'Markets closed', type: 'ArrowDown',
                textStyle: { color: 'white' }, background: '#3ab0f9', border: { color: '#3ab0f9' }
            },
            {
                date: new Date('2015-01-07'), text: 'A', description: 'This is event description',
                textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' }
            },
            {
                date: new Date(2015, 1, 2), text: 'Q1', description: 'Add longer text',
                textStyle: { color: 'white' }, background: '#dd3c9f', border: { color: '#dd3c9f' }, type: 'Text'
            },
            {
                date: new Date(2015, 2, 12), text: 'Close', description: 'Markets closed',
                textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' }
            }
        ]}>
            <Inject services={[DateTime, StripLine, LineSeries, Crosshair, SplineSeries, CandleSeries, HiloOpenCloseSeries, HiloSeries, RangeAreaSeries, Trendlines,
            EmaIndicator, RsiIndicator, BollingerBands, TmaIndicator, MomentumIndicator, SmaIndicator, AtrIndicator, Export,
            AccumulationDistributionIndicator, MacdIndicator, StochasticIndicator]}/>
            <StockChartSeriesCollectionDirective>
                <StockChartSeriesDirective dataSource={aapl} type='Spline' xName='x' width={2} yName='high' name='google' close='high'>
                </StockChartSeriesDirective>
            </StockChartSeriesCollectionDirective>
        </StockChartComponent>;
}
;
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    StockChartComponent, StockChartSeriesCollectionDirective, StockChartSeriesDirective, Inject,
    DateTime, StripLine, LineSeries, SplineSeries, CandleSeries, HiloOpenCloseSeries, HiloSeries,
    RangeAreaSeries, Trendlines, ChartTheme, IStockChartEventArgs, Crosshair
} from '@syncfusion/ej2-react-charts';
import {
    EmaIndicator, RsiIndicator, BollingerBands, TmaIndicator, MomentumIndicator, SmaIndicator, AtrIndicator,
    AccumulationDistributionIndicator, MacdIndicator, StochasticIndicator, Export
} from '@syncfusion/ej2-react-charts';
import { aapl } from '../datasource';

function App() {
    const primaryxAxis: AxisModel = {
        valueType: 'DateTime', majorGridLines: { color: 'transparent' },
        crosshairTooltip: { enable: true }
    };
    const primaryyAxis: AxisModel = {
        lineStyle: { color: 'transparent' },
        majorTickLines: { color: 'transparent' },
        crosshairTooltip: { enable: true }
    };
    return <StockChartComponent id='stockcharts'
            primaryXAxis={primaryxAxis}
            primaryYAxis={primaryyAxis}
            indicatorType={[]}
            seriesType={[]}
            trendlineType={[]}
            title='AAPL Stock Price'
            height='350'
            stockEvents={[
                { date: new Date(2012, 3, 1), text: 'Q2', description: '2012 Quarter2 starts', type: 'Flag' },
                {
                    date: new Date(2012, 3, 20), text: 'Open', description: 'Markets opened', textStyle: { color: 'white' },
                    background: '#f48a21', border: { color: '#f48a21' }
                },
                {
                    date: new Date(2012, 6, 1), text: 'Q3', description: '2013 Quarter3 starts', type: 'Flag',
                    textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }
                },
                {
                    date: new Date(2012, 9, 1), text: 'Q4', description: '2013 Quarter4 starts', type: 'Flag',
                    textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }
                },
                {
                    date: new Date(2012, 7, 30), text: 'G', description: 'Google stocks bought',
                    textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' }
                },
                {
                    date: new Date(2012, 10, 1), text: 'Y', description: 'Yahoo stocks sold', type: 'Square',
                    textStyle: { color: 'white' }, background: '#841391', border: { color: '#841391' }
                },
                {
                    date: new Date(2012, 12, 0), text: 'Y2', description: 'Year 2013', type: 'Pin', showOnSeries: false,
                    textStyle: { color: 'white' }, background: '#6322e0', border: { color: '#6322e0' }
                },
                {
                    date: new Date(2013, 3, 1), text: 'Q2', description: '2013 Quarter2 starts', type: 'Flag',
                    textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }
                },
                {
                    date: new Date(2013, 3, 20), text: 'Q2', description: 'Surge in Stocks', type: 'ArrowUp',
                    textStyle: { color: 'white' }, background: '#3ab0f9', border: { color: '#3ab0f9' }
                },
                {
                    date: new Date(2013, 6, 1), text: 'Q3', description: '2013 Quarter3 starts', type: 'Flag',
                    textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }
                },
                {
                    date: new Date(2013, 9, 1), text: 'Q4', description: '2013 Quarter4 starts', type: 'Flag',
                    textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }
                },
                {
                    date: new Date(2013, 12, 0), text: 'Y3', description: 'Year 2014', type: 'Pin', showOnSeries: false,
                    textStyle: { color: 'white' }, background: '#6322e0', border: { color: '#6322e0' }
                },
                {
                    date: new Date(2014, 3, 1), text: 'Q2', description: '2014 Quarter2 starts', type: 'ArrowDown',
                    textStyle: { color: 'white' }, background: '#3ab0f9', border: { color: '#3ab0f9' }
                },
                {
                    date: new Date(2014, 6, 1), text: 'Q3', description: '2014 Quarter3 starts',
                    textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' }
                },
                {
                    date: new Date(2014, 9, 1), text: 'Q4', description: '2014 Quarter4 starts', type: 'Flag',
                    textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }
                },
                {
                    date: new Date(2014, 12, 0), text: 'Y4', description: 'Year 2015', type: 'Pin', showOnSeries: false,
                    textStyle: { color: 'white' }, background: '#6322e0', border: { color: '#6322e0' }
                },
                {
                    date: new Date(2014, 2, 2), text: 'End', description: 'Markets closed', type: 'ArrowDown',
                    textStyle: { color: 'white' }, background: '#3ab0f9', border: { color: '#3ab0f9' }
                },
                {
                    date: new Date('2015-01-07'), text: 'A', description: 'This is event description',
                    textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' }
                },
                {
                    date: new Date(2015, 1, 2), text: 'Q1', description: 'Add longer text',
                    textStyle: { color: 'white' }, background: '#dd3c9f', border: { color: '#dd3c9f' }, type: 'Text'
                },
                {
                    date: new Date(2015, 2, 12), text: 'Close', description: 'Markets closed',
                    textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' }
                }
            ]}
        >
            <Inject services={[DateTime, StripLine, LineSeries, Crosshair, SplineSeries, CandleSeries, HiloOpenCloseSeries, HiloSeries, RangeAreaSeries, Trendlines,
                EmaIndicator, RsiIndicator, BollingerBands, TmaIndicator, MomentumIndicator, SmaIndicator, AtrIndicator, Export,
                AccumulationDistributionIndicator, MacdIndicator, StochasticIndicator]} />
            <StockChartSeriesCollectionDirective>
                <StockChartSeriesDirective dataSource={aapl} type='Spline' xName='x' width={2} yName='high' name='google' close='high'>
                </StockChartSeriesDirective>
            </StockChartSeriesCollectionDirective>
        </StockChartComponent>

};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));

Stock Events for individual series

By default, stock events will be showed for all series. Now, you can set the stock events for particular series using seriesIndexes property.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { StockChartComponent, StockChartSeriesCollectionDirective, StockChartSeriesDirective, Inject, DateTime, StripLine, LineSeries, SplineSeries, CandleSeries, HiloOpenCloseSeries, HiloSeries, RangeAreaSeries, Trendlines, Crosshair } from '@syncfusion/ej2-react-charts';
import { EmaIndicator, RsiIndicator, BollingerBands, TmaIndicator, MomentumIndicator, SmaIndicator, AtrIndicator, AccumulationDistributionIndicator, MacdIndicator, StochasticIndicator, Export } from '@syncfusion/ej2-react-charts';
import { chartData } from '../datasource';
function App() {
    const primaryxAxis = {
        valueType: 'DateTime', majorGridLines: { color: 'transparent' }, crosshairTooltip: { enable: true }
    };
    const primaryyAxis = {
        lineStyle: { color: 'transparent' }, majorTickLines: { color: 'transparent' }, crosshairTooltip: { enable: true }
    };
    return <StockChartComponent id='stockcharts' primaryXAxis={primaryxAxis} primaryYAxis={primaryyAxis} indicatorType={[]} seriesType={[]} trendlineType={[]} title='AAPL Stock Price' height='350' stockEvents={[
            { date: new Date(2012, 3, 1), text: 'Q2', description: '2012 Quarter2 starts', type: 'Flag', background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes: [0] },
            { date: new Date(2012, 3, 20), text: 'Open', description: 'Markets opened', textStyle: { color: 'white' },
                background: '#f48a21', border: { color: '#f48a21' }, seriesIndexes: [0] },
            { date: new Date(2012, 6, 1), text: 'Q3', description: '2013 Quarter3 starts', type: 'Flag',
                textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes: [0] },
            { date: new Date(2012, 9, 1), text: 'Q4', description: '2013 Quarter4 starts', type: 'Flag',
                textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes: [0] },
            { date: new Date(2012, 7, 30), text: 'G', description: 'Google stocks bought',
                textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' }, seriesIndexes: [0] },
            { date: new Date(2012, 10, 1), text: 'Y', description: 'Yahoo stocks sold', type: 'Square',
                textStyle: { color: 'white' }, background: '#841391', border: { color: '#841391' }, seriesIndexes: [0] },
            { date: new Date(2012, 12, 0), text: 'Y2', description: 'Year 2013', type: 'Pin', showOnSeries: false,
                textStyle: { color: 'white' }, background: '#6322e0', border: { color: '#6322e0' }, seriesIndexes: [0] },
            { date: new Date(2013, 3, 1), text: 'Q2', description: '2013 Quarter2 starts', type: 'Flag',
                textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes: [0] },
            { date: new Date(2013, 3, 20), text: 'Q2', description: 'Surge in Stocks', type: 'ArrowUp',
                textStyle: { color: 'white' }, background: '#3ab0f9', border: { color: '#3ab0f9' }, seriesIndexes: [1] },
            { date: new Date(2013, 6, 1), text: 'Q3', description: '2013 Quarter3 starts', type: 'Flag',
                textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes: [1] },
            { date: new Date(2013, 9, 1), text: 'Q4', description: '2013 Quarter4 starts', type: 'Flag',
                textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes: [1] },
            { date: new Date(2013, 12, 0), text: 'Y3', description: 'Year 2014', type: 'Pin', showOnSeries: false,
                textStyle: { color: 'white' }, background: '#6322e0', border: { color: '#6322e0' }, seriesIndexes: [1] },
            { date: new Date(2014, 3, 1), text: 'Q2', description: '2014 Quarter2 starts', type: 'ArrowDown',
                textStyle: { color: 'white' }, background: '#3ab0f9', border: { color: '#3ab0f9' }, seriesIndexes: [1] },
            { date: new Date(2014, 6, 1), text: 'Q3', description: '2014 Quarter3 starts',
                textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' }, seriesIndexes: [2] },
            { date: new Date(2014, 9, 1), text: 'Q4', description: '2014 Quarter4 starts', type: 'Flag',
                textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes: [2] },
            { date: new Date(2014, 12, 0), text: 'Y4', description: 'Year 2015', type: 'Pin', showOnSeries: false,
                textStyle: { color: 'white' }, background: '#6322e0', border: { color: '#6322e0' }, seriesIndexes: [2] },
            { date: new Date(2014, 2, 2), text: 'End', description: 'Markets closed', type: 'ArrowDown',
                textStyle: { color: 'white' }, background: '#3ab0f9', border: { color: '#3ab0f9' }, seriesIndexes: [2] },
            { date: new Date('2015-01-07'), text: 'A', description: 'This is event description',
                textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' }, seriesIndexes: [2] },
            { date: new Date(2015, 1, 2), text: 'Q1', description: 'Add longer text',
                textStyle: { color: 'white' }, background: '#dd3c9f', border: { color: '#dd3c9f' }, type: 'Text', seriesIndexes: [2] },
            { date: new Date(2015, 2, 12), text: 'Close', description: 'Markets closed',
                textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' }, seriesIndexes: [2] }
        ]}>
            <Inject services={[DateTime, StripLine, LineSeries, Crosshair, SplineSeries, CandleSeries, HiloOpenCloseSeries, HiloSeries, RangeAreaSeries, Trendlines,
            EmaIndicator, RsiIndicator, BollingerBands, TmaIndicator, MomentumIndicator, SmaIndicator, AtrIndicator, Export,
            AccumulationDistributionIndicator, MacdIndicator, StochasticIndicator]}/>
            <StockChartSeriesCollectionDirective>
                <StockChartSeriesDirective dataSource={chartData} type='Spline' xName='date' width={2} yName='high'>
                </StockChartSeriesDirective>
                <StockChartSeriesDirective dataSource={chartData} type='Spline' xName='date' width={2} yName='low'>
                </StockChartSeriesDirective>
                <StockChartSeriesDirective dataSource={chartData} type='Spline' xName='date' width={2} yName='open'>
                </StockChartSeriesDirective>
            </StockChartSeriesCollectionDirective>
        </StockChartComponent>;
}
;
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import {
    StockChartComponent, StockChartSeriesCollectionDirective, StockChartSeriesDirective, Inject,
    DateTime, StripLine, LineSeries, SplineSeries, CandleSeries, HiloOpenCloseSeries, HiloSeries,
    RangeAreaSeries, Trendlines, ChartTheme, IStockChartEventArgs, Crosshair
} from '@syncfusion/ej2-react-charts';
import {
    EmaIndicator, RsiIndicator, BollingerBands, TmaIndicator, MomentumIndicator, SmaIndicator, AtrIndicator,
    AccumulationDistributionIndicator, MacdIndicator, StochasticIndicator, Export
} from '@syncfusion/ej2-react-charts';
import { chartData } from '../datasource';

function App() {
    const primaryxAxis: AxisModel = {
        valueType: 'DateTime', majorGridLines: { color: 'transparent' }, crosshairTooltip: { enable: true }
    };
    const primaryyAxis: AxisModel = {
        lineStyle: { color: 'transparent' }, majorTickLines: { color: 'transparent' }, crosshairTooltip: { enable: true }
    };
    return <StockChartComponent id='stockcharts'
            primaryXAxis={primaryxAxis}
            primaryYAxis={primaryyAxis}
            indicatorType={[]}
            seriesType={[]}
            trendlineType={[]}
            title='AAPL Stock Price'
            height='350'
            stockEvents={[
                { date: new Date(2012, 3, 1), text: 'Q2', description: '2012 Quarter2 starts', type: 'Flag', background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes: [0] },
            { date: new Date(2012, 3, 20), text: 'Open', description: 'Markets opened', textStyle: { color: 'white' },
              background: '#f48a21', border: { color: '#f48a21' }, seriesIndexes: [0] },
            { date: new Date(2012, 6, 1), text: 'Q3', description: '2013 Quarter3 starts', type: 'Flag',
              textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes: [0] },
            { date: new Date(2012, 9, 1), text: 'Q4', description: '2013 Quarter4 starts', type: 'Flag',
              textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes: [0] },
            { date: new Date(2012, 7, 30), text: 'G', description: 'Google stocks bought',
              textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' }, seriesIndexes: [0] },
            { date: new Date(2012, 10, 1), text: 'Y', description: 'Yahoo stocks sold', type: 'Square',
              textStyle: { color: 'white' }, background: '#841391', border: { color: '#841391' }, seriesIndexes: [0] },
            { date: new Date(2012, 12, 0), text: 'Y2', description: 'Year 2013', type: 'Pin', showOnSeries: false,
              textStyle: { color: 'white' }, background: '#6322e0', border: { color: '#6322e0' }, seriesIndexes: [0] },
            { date: new Date(2013, 3, 1), text: 'Q2', description: '2013 Quarter2 starts', type: 'Flag',
              textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes: [0] },
            { date: new Date(2013, 3, 20), text: 'Q2', description: 'Surge in Stocks', type: 'ArrowUp',
              textStyle: { color: 'white' }, background: '#3ab0f9', border: { color: '#3ab0f9' }, seriesIndexes: [1] },
            { date: new Date(2013, 6, 1), text: 'Q3', description: '2013 Quarter3 starts', type: 'Flag',
              textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes: [1] },
            { date: new Date(2013, 9, 1), text: 'Q4', description: '2013 Quarter4 starts',  type: 'Flag',
              textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes: [1] },
            { date: new Date(2013, 12, 0), text: 'Y3', description: 'Year 2014', type: 'Pin', showOnSeries: false,
              textStyle: { color: 'white' }, background: '#6322e0', border: { color: '#6322e0' }, seriesIndexes: [1] },
            { date: new Date(2014, 3, 1), text: 'Q2', description: '2014 Quarter2 starts', type: 'ArrowDown',
              textStyle: { color: 'white' }, background: '#3ab0f9', border: { color: '#3ab0f9' }, seriesIndexes: [1] },
            { date: new Date(2014, 6, 1), text: 'Q3', description: '2014 Quarter3 starts',
              textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' }, seriesIndexes: [2] },
            { date: new Date(2014, 9, 1), text: 'Q4', description: '2014 Quarter4 starts', type: 'Flag',
              textStyle: { color: 'white' }, background: '#6c6d6d', border: { color: '#6c6d6d' }, seriesIndexes: [2] },
            { date: new Date(2014, 12, 0), text: 'Y4', description: 'Year 2015', type: 'Pin', showOnSeries: false,
              textStyle: { color: 'white' }, background: '#6322e0', border: { color: '#6322e0' }, seriesIndexes: [2] },
            { date: new Date(2014, 2, 2), text: 'End', description: 'Markets closed', type: 'ArrowDown',
              textStyle: { color: 'white' }, background: '#3ab0f9', border: { color: '#3ab0f9' }, seriesIndexes: [2] },
            { date: new Date('2015-01-07'), text: 'A', description: 'This is event description',
              textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' }, seriesIndexes: [2] },
            { date: new Date(2015, 1, 2), text: 'Q1', description: 'Add longer text',
              textStyle: { color: 'white' }, background: '#dd3c9f', border: { color: '#dd3c9f' }, type: 'Text', seriesIndexes: [2] },
            { date: new Date(2015, 2, 12), text: 'Close', description: 'Markets closed',
              textStyle: { color: 'white' }, background: '#f48a21', border: { color: '#f48a21' }, seriesIndexes: [2] }
            ]}
        >
            <Inject services={[DateTime, StripLine, LineSeries, Crosshair, SplineSeries, CandleSeries, HiloOpenCloseSeries, HiloSeries, RangeAreaSeries, Trendlines,
                EmaIndicator, RsiIndicator, BollingerBands, TmaIndicator, MomentumIndicator, SmaIndicator, AtrIndicator, Export,
                AccumulationDistributionIndicator, MacdIndicator, StochasticIndicator]} />
            <StockChartSeriesCollectionDirective>
                <StockChartSeriesDirective dataSource={chartData} type='Spline' xName='date' width={2} yName='high'>
                </StockChartSeriesDirective>
                <StockChartSeriesDirective dataSource={chartData} type='Spline' xName='date' width={2} yName='low'>
                </StockChartSeriesDirective>
                <StockChartSeriesDirective dataSource={chartData} type='Spline' xName='date' width={2} yName='open'>
                </StockChartSeriesDirective>
            </StockChartSeriesCollectionDirective>
        </StockChartComponent>
};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));

See Also